namespace CMSMicroservice.Application.UserCartsCQ.Commands.UpdateUserCarts;
public class UpdateUserCartsCommandValidator : AbstractValidator<UpdateUserCartsCommand>
{
    public UpdateUserCartsCommandValidator()
    {
        RuleFor(model => model.Id)
            .NotNull();
        RuleFor(model => model.Count)
            .NotNull();
    }
    public Func<object, string, Task<IEnumerable<string>>> ValidateValue => async (model, propertyName) =>
    {
        var result = await ValidateAsync(ValidationContext<UpdateUserCartsCommand>.CreateWithOptions((UpdateUserCartsCommand)model, x => x.IncludeProperties(propertyName)));
        if (result.IsValid)
            return Array.Empty<string>();
        return result.Errors.Select(e => e.ErrorMessage);
    };
}
